code	segment	'code'
	assume	cs:code,ds:code

	org	2ch
envseg	label	word			; pointer to environment segment

	org	100h
start:	jmp	near ptr init		; jump to install routine
	dw	0

new21:	cmp	ah,67h			; change handle table size?
	jne	start
	cmp	bx,20			; more than 20 handles?
	jbe	start

	push	bp			; save registers
	mov	bp,sp
	push	ds
	push	cx
	push	bx

	mov	cx,bx			; copy requested table size
	inc	cx			; DOSBox adds 2 extra handles
	inc	cx

	mov	ah,62h			; get current PSP
	int	21h
	mov	ah,67h			; restore function
	mov	ds,bx
	pop	bx

	cmp	word ptr ds:[32h],cx	; table size changed?
	pop	cx
	pop	ds
	je	nochg			; do nothing if same size,
	pop	bp			; otherwise proceed
	jmp	start
nochg:	and	word ptr [bp+6],not 1	; clear carry flag on stack
	pop	bp
	iret

init:	mov	ax,3521h		; create jump to previous handler
	int	21h
	inc	byte ptr start
	mov	word ptr start+1,bx
	mov	word ptr start+3,es

	mov	dx,offset new21		; hook into chain
	mov	ah,25h
	int	21h

	mov	es,envseg		; free env seg to save memory
	mov	ah,49h
	int	21h

	mov	dx,0014h		; terminate leaving DX paras resident
	mov	ax,3100h
	int	21h

code	ends

	end	start
